unit Unitealgo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls;

Const n = 15;         (*nombre de stations*)
      capacite = 200; (*par rame*)
      T_fonc = 19;    (*Heures de fonctionnement du mtro par jour*)
      Capa_max = 500; (*A vrifier que ca sert: capacit max des stations *)
      T_attente = 10;
      essai_max = 500 ; //DEBUG nbre d'itrations par clic
      T_max = 1000;     (*Periode entre deux rames*)

type


  TForm1 = class(TForm)
    Bouton1: TButton;
    Button1: TButton;
    Timer1: TTimer;
    UpDown1: TUpDown;
    Edit1: TEdit;
    Label1: TLabel;

    procedure Bouton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
  private
    { Private declarations }
  public

    { Public declarations }
  end;

 Tstation =
   object
   T_suivant   : word;
   Nom_Station : string;
   Popularite  : byte; {Entre 1 et 10}
   n_passagers : word; (*nombre de passagers en attente *)
   x,y         : word;
   {Mthodes}
   Procedure init(T: word;Nom:string;Pop:byte;nx,ny : word);
   Procedure creation(sens,pos:byte);
  end;


Prame = ^Trame;

Trame =
object
  cpt         : integer; (*timer de la rame*)
  n_passager : word;
  vitesse     : word;
  dest        : array[0..2*n-1]of word; (*passagers par destination*)
  panne       : boolean;
  r_suivant   : Prame;
  destination : byte; (*numero de la station suivante ou actuelle*)

  {Mthodes}
  Procedure create;
  Procedure destruct;
  Procedure Action;
  Procedure Attente;
  Procedure Avance;

end;
   Procedure Initialisation;
var
  Form1: TForm1;
  Affluence : array[0..n-1] of word;(*affluence horaire pour la station k*)
  Pt,Pr,ListeRame : Prame;
  i,j,nrame,temps:integer;
  station : array[0..n-1,0..1] of Tstation;
  NTOTAL,NtotalOld,frequence : longint;
  coeff : integer;

implementation

uses Unitegraph;

{$R *.DFM}

{*************************** Creation des methodes **************************}



procedure Tstation.init(T: word;Nom:string;Pop:byte;nx,ny : word);
begin

frequence := 200;
n_passagers := 0;
Nom_station := Nom;
T_suivant := T;
Popularite := Pop;
x := nx;
y := ny;
end;


Procedure Tstation.creation(sens,pos:byte);
var r:integer;
begin
if pos<>n-1 then begin
r:=5*random(150);(*empirique*)
if r<affluence[abs((n-1)*sens-pos)] then begin inc(n_passagers,coeff);inc(NTOTAL,coeff);end;
end;


end;


procedure Trame.create;
var r,rt:prame;
   i:integer;
begin
temps:=0;
rt:=r_suivant;     {On sauvegarde l'ancien pointeur}
New(r);
r_suivant:=r;       {on cre les nouveaux liens}
r^.r_suivant:=rt;
r^.destination :=0;
r^.cpt:=0;
r^.n_passager:=0;
for i:=0 to 2*n-1 do r^.dest[i]:=0;
end;


Procedure Trame.destruct;
var p,pt:prame;
begin
pt:=Listerame;
while pt^.r_suivant^.r_suivant<>Nil do pt:=pt^.r_suivant;
p:=pt^.r_suivant;
pt^.r_suivant:=Nil;
//form1.progressbar1.position:=form1.progressbar1.position-1;
dispose(p);
end;

Procedure Trame.Action;
begin
cpt:=cpt-1;
if cpt>0 then avance else attente;
end;

Procedure Trame.Attente;
var po,p,pos,sens,r,dif:integer;
    pop:array[0..n-1] of integer;

begin

pos:= destination mod n ;
sens:= destination div n ;

If cpt=0 then
begin
n_passager:=n_passager-dest[destination];dest[destination]:=0;
end
else

if cpt=-1 then
begin
if pos <>n-1 then
begin
dif:=capacite-n_passager;
while (dif>0) and (station[pos,sens].n_passagers>0) do
begin
dif:=dif-1;
for r:=0 to n-1 do pop[r]:=0;
po:=0;

for r:=pos+1 to n-1 do begin po:=po+station[r,sens].popularite;pop[r]:=po;end;
p:=random(po);
r:=pos+1;
while p>pop[r] do r:=r+1;
dec(station[pos,sens].n_passagers);
dest[r+n*sens]:=dest[r+n*sens]+1;
dec(NTOTAL);
n_passager:=n_passager+1;
end;
end;
end
else

if cpt=-T_attente then
begin
r:=random(2);
cpt:=cpt + 5*r;
end
else


if cpt<-T_attente then
begin
if(r_suivant)<>NIl then
begin
if (r_suivant^.cpt>=0) and (destination+1<>r_suivant^.destination) then
begin
cpt:=station[destination mod n, destination div n].T_suivant;
destination := (destination+1);
end;

end
else
begin
cpt:=station[destination mod n, destination div n].T_suivant;
destination := (destination+1);
if destination = 2*n then destruct;
end;
end;
end;



Procedure Trame.Avance;
begin
(* *)
end;


{****************************** Fin des methodes ****************************}




Procedure Initialisation;
var f:text;
    i,t,p:integer;
    nom:string;
    nx,ny : word;
begin
NTOTAL:=0;
randomize;
new(listerame);
listerame^.r_suivant:=Nil;
assignfile(f,'name.txt');
reset(f);
for i:= 0 to n-1 do
begin
read(f,t);read(f,p);read(f,nx);read(f,ny);read(f,nom);station[i,0].init(t,nom,p,nx,ny);
read(f,t);read(f,p);read(f,nx);read(f,ny);read(f,nom);station[n-1-i,1].init(t,nom,p,nx,ny);
end;

for i :=0 to n-1 do read(f,affluence[i]);

closefile(f);

{calcul du temps du parcours}
temps:=0;
listerame.create;
coeff :=1;
end;


Procedure fin;
var pt,pr:prame;
begin
pt:=listerame^.r_suivant;

while pt<>Nil do
begin
  pr:=pt^.r_suivant;
  pt^.destruct;
  pt:=pr;
end;
dispose(listerame);
end;


procedure essai;
var pt,pr:prame;
begin
inc(temps);

if  ((frequence<temps) or (temps>T_max) or (Ntotal>800))and (listerame^.r_suivant^.destination<>0) then begin
 listerame^.create;

end;
pt:=listerame^.r_suivant;
while pt<>Nil do
begin
// APPEL de la procdure du rendu graphique
  Form2.affiche_rame(pt^.cpt,pt^.destination,pt^.n_passager);
  pr:=pt^.r_suivant;
  pt^.action;
  pt:=pr;
end;
Ntotalold:=Ntotal;
for i:=0 to n-1 do for j:=0 to 1 do station[i,j].creation(j,i);
frequence := round((frequence + 1000/(Ntotal-ntotalold+1))/2);
Form2.affiche_stations ; //affiche les stats des stations

end;


procedure TForm1.Bouton1Click(Sender: TObject);
begin
fin;
halt;
end;


procedure TForm1.Button1Click(Sender: TObject);
var i:longint;
begin
for i:=1 to essai_max do begin essai;end;
//essai;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
essai;
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
 coeff := updown1.position;
end;

end.
