unit Unitegraph;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,Unitealgo;

type
  TForm2 = class(TForm)
    PaintBox1: TPaintBox;
    procedure affiche_rame(dist,dest,npassager : integer);
    procedure affiche_stations ;
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  BmpF : Tbitmap;       // bitmap de fond (carte)
  BmpM : Tbitmap;       // bitmap de manoeuvre pour dessins cachs
  Rnew,Rold,rtext : Trect;    //Dfini les rectangles pour la zone d'affichage  effacer
implementation

//uses Unitealgo;

{$R *.DFM}
procedure Tform2.affiche_stations ;
//Procedure qui affiche l'affluence dans les stations
var npstation,n_total : string; // nbre de passagers par station
    z : integer;
begin
 for z:=0 to n-1 do begin
   str(station[z,0].n_passagers + station[n-1-z,1].n_passagers,npstation);
   Form2.Canvas.Textout(50, 50+z*20,station[z,1].Nom_Station);
   Form2.Canvas.Textout(150, 50+z*20,npstation + '   ');
   str(NTOTAL, n_total);
   Form2.Canvas.Textout(50, 50+n*20,' Total en attente');
   Form2.Canvas.Textout(150, 50+n*20,n_total + '   ');
 end;
end;

procedure TForm2.affiche_rame(dist,dest,npassager : integer);
//Procedure qui affiche les rames
var l : real;
    x,y : word; //coordonnes sur la PaintBox
    runion : Trect;
    np : string;
    //DEBUG
//    xx,yy,tt,dd,dd2,ll : string;
begin
  if (dist>=0) and (dest>0) then begin
    BmpM.Canvas.font.color:=ClBlack;
    l := dist / station[dest mod n -1,dest div n].T_suivant ;    //calcul de lambda
    x := round(l*station[dest mod n -1,dest div n].x + (1-l)*station[dest mod n ,dest div n].x);
    y := round(l*station[dest mod n -1,dest div n].y + (1-l)*station[dest mod n ,dest div n].y);
  end else Bmpm.Canvas.font.color:=ClRed;
  //gestion de l'affichage;
  Rold := bounds(x-4, y-4, 8, 8);
 {  1 - effacements dans Bmpm de tous les dessins  leur ancienne
    position,  partir du bitmap Bmpf }
  BmpM.Canvas.CopyRect(ROld,bmpF.canvas,ROld);
  BmpM.Canvas.CopyRect(Rtext,bmpF.canvas,Rtext);
  str(npassager:3,np);
 {  2 - affichage cach dans Bmpm}
  RNew := bounds(x-3, y-3, 6, 6);  // rectangle nouvelle position
  if dest<=n then begin
   //Form2.Canvas.PolyLine([Point(x,y),Point(x-5,y-23)]);
   Rtext := bounds(x-22, y-38, 20, 12);  // rectangle texte
   BmpM.Canvas.Textout(x-22, y-38, np);

  end
  else begin
   //Form2.Canvas.PolyLine([Point(x+9,y+9),Point(x+22,y+26)]);
   Rtext := bounds(x+5, y+20, 20, 12);  // rectangle texte
   BmpM.Canvas.Textout(x+5, y+20, np);

  end;
  BmpM.Canvas.Ellipse(x-3, y-3, x+3, y+3);
  //affichage nbre passagers au dessus des rames



 {  3 - affichage sur le canvas de la zone modifie, c'est
       dire l'union des rectangles ancienne et nouvelle position }
  UnionRect(RUnion, ROld, RNew);
  PaintBox1.Canvas.CopyRect(Rtext, BmpM.Canvas,Rtext);
  PaintBox1.Canvas.CopyRect(RUnion, BmpM.Canvas,RUnion);

end;

procedure TForm2.PaintBox1Paint(Sender: TObject);
begin
// on actualise la Canevas quand on le modifie
 Form2.PaintBox1.Canvas.Draw(0,0,BmpM);
end;



procedure TForm2.FormCreate(Sender: TObject);
begin
//gestion Bitmap :
  Bmpf := Tbitmap.create;  // bitmap de fond
  Bmpf.LoadFromFile('VAL-map.bmp');
  BmpM := tbitmap.create;
  BmpM.assign(Bmpf);      // copie de BmpF sur BmpM
end;

end.
